#ifndef TETRIS_H
#define TETRIS_H

#include <windows.h>

#define NUM_ROWS 35		// # of rows
#define NUM_COLS 22		// # of columns
#define NUM_FIGURES 10	// # of figures
#define NUM_ACCELS 24	// # of accelerators
#define SIDE 3			// figures side length

#define WM_UPDATEDATA				WM_USER + 1

#define ID_TIMER					101

#define IDM_GAME_NEW				102
#define IDM_GAME_PAUSE				103
#define IDM_GAME_HIGHSCORES			104
#define IDM_GAME_EXIT				105

#define IDM_CONTROL_LEFT			106
#define IDM_CONTROL_RIGHT			107
#define IDM_CONTROL_DOWN			108
#define IDM_CONTROL_ROTATE			109
#define IDM_CONTROL_FORCE_LEFT		110
#define IDM_CONTROL_FORCE_RIGHT		111
#define IDM_CONTROL_FORCE_DOWN		112

#define IDM_OPTIONS_SPEED_1			113
#define IDM_OPTIONS_SPEED_2			114
#define IDM_OPTIONS_SPEED_3			115
#define IDM_OPTIONS_SPEED_4			116
#define IDM_OPTIONS_COLOR_BACK		117
#define IDM_OPTIONS_COLOR_BLOCK		118
#define IDM_OPTIONS_KEYBINDINGS		119
#define IDM_OPTIONS_NEXT			120
#define IDM_OPTIONS_GRID			121
#define IDM_OPTIONS_LAND			122
#define IDM_OPTIONS_WINDOW_TOPMOST	123
#define IDM_OPTIONS_WINDOW_EASYMOVE	124
#define IDM_OPTIONS_SAVE			125

#define IDM_HELP_README				126
#define IDM_HELP_ABOUT				127

#define IDC_NAME1					101
#define IDC_NAME2					102
#define IDC_NAME3					103
#define IDC_SCORE1					104
#define IDC_SCORE2					105
#define IDC_SCORE3					106

#define IDL_KEYNAMES				101
#define IDC_CTRL					102
#define IDC_SHIFT					103
#define IDC_ALT						104
#define IDC_KEYS					105
#define IDDEFAULTS					106

typedef struct { char name[31]; int score; } RECORDS;
typedef enum { btZero, btStatic, btActive } BLOCK_TYPE;
enum { opSpeed, opBack, opBlock, opNext, opGrid, opLand, opTopmost, opEasyMove };

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK HighScoresProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK KeyBindingsProc(HWND, UINT, WPARAM, LPARAM);
BOOL isDefaultAccels(const ACCEL []);
BOOL isConflictingAccels(const ACCEL []);
int adjustKey(int, BOOL);
void putBlockEx(int [][NUM_COLS], int (*) [SIDE], int, int, BLOCK_TYPE);
void writeScore(HWND, int, int);
void refreshMenu(HMENU, const ACCEL [], BOOL, BOOL, const int []);

#endif // TETRIS_H
